function setup() {
  createCanvas(windowWidth, windowHeight);   // full-page canvas
  background(0); // background black
}

function draw() {
}

function mousePressed() {
  drawFlower(mouseX, mouseY);   // Draw flower at the mouse position
}

function drawFlower(x, y) {
  let petals = int(random(6, 12)); // Random number of petals
  let radius = random(40, 100); // Random size of the flower
  let petalColor = color(random(0, 255), random(50, 250), random(100, 255)); // Random petal color
  let centerColor = color(255, 200, 0); // Pure yellow for the center

  push(); 
  translate(x, y); // Move flower's position

  for (let i = 0; i < petals; i++) {
    let angle = TWO_PI / petals * i; // Angle for each petal
    let petalLength = radius + random(-10, 10); // A Slight randomness in petal size
    let petalWidth = radius / 3 + random(-5, 5);
    let petalGradient = lerpColor(petalColor, color(255), 0.5);

    push();
    rotate(angle); // Rotate to position the petal
    fill(petalGradient);
    noStroke();
    beginShape();
    vertex(0, 0); // Start at center
    bezierVertex(petalWidth / 2, -petalLength / 2, petalWidth / 2, -petalLength, 0, -petalLength); 
    bezierVertex(-petalWidth / 2, -petalLength, -petalWidth / 2, -petalLength / 2, 0, 0); 
    endShape(CLOSE);
    pop();
  }

  fill(centerColor);
  noStroke();
  ellipse(0, 0, radius / 3);

  pop();
}

function windowResized() {
  resizeCanvas(windowWidth, windowHeight);
  background(0); 
}
